/**
 * Example of how to call the TCB GetTimestamp and 
 * GetGlobalTimestamp services.
 * 
 * @author Paulo Sousa
 */
#include "stdafx.h"
//include tcb services library header file
#include "..\..\tcb_services_library\tcb_services_library.h"

int main(int argc, char* argv[]){

	//open_session
	printf("Opening TCB session\n");
	int error = open_tcb_session();
	if (error!=0) {
		printf("Error opening session=%d\n",error);
		getchar();
		return -1;
	}
	
	//get_timestamp
	printf("Getting timestamp\n");
	int timestamp = get_tcb_timestamp();
	printf("Timestamp=%d\n", timestamp);

	//get_global_timestamp
	printf("Getting global timestamp at %d\n", timestamp);
	timestamp = get_tcb_global_timestamp(timestamp);
	printf("Global Timestamp=%d\n", timestamp);
	printf("Getting current global timestamp\n");
	timestamp = get_tcb_global_timestamp(0);
	printf("Current Global Timestamp=%d\n", timestamp);

	//close_session
	printf("Closing session\n");
	error=close_tcb_session();
	if (error!=0) {
		printf("Error closing session=%d\n",error);
		getchar();
		return -1;
	}
	printf("Close ok!\n");

	//wait for user to press a key
	printf("Press a key to close window...\n");
	getchar();
	return 0;
}
