/**
 * Example of how to call the TCB LocalMeasurement service.
 * 
 * @author Paulo Sousa
 */

#include "stdafx.h"
//include tcb services library header file
#include "..\..\tcb_services_library\tcb_services_library.h"

int main(int argc, char* argv[]) {

	//open_session
	printf("Opening TCB session\n");
	int error = open_tcb_session();
	if (error!=0) {
		printf("Error opening session=%d\n",error);
		getchar();
		return -1;
	}

	//start_local_measurement
	printf("Starting local measurement\n");
	int st_timestamp=get_tcb_timestamp();
	int tag=start_tcb_local_measurement(st_timestamp);
	if(tag<0) {
		printf("Error starting measurement=%d\n", tag);
	}

	
	/*computation to be measured should be putted here*/
	
	//simulates a computation that takes 3 ms
	Sleep(3);


	//end_local_measurement
	tcb_measurement_info_t mi = end_tcb_local_measurement(tag);
	if (mi.end_ev==-1) {
		printf("Error ending measurement=%d\n", mi.end_ev);
	}
	else printf("Local measurement: duration=%d\n", mi.procdelay);

	//close_session
	printf("Closing session\n");
	error=close_tcb_session();
	if (error!=0) {
		printf("Error closing session=%d\n",error);
		getchar();
		return -1;
	}
	printf("Close ok!\n");

	//wait for user to press a key
	printf("Press a key to close window...\n");
	getchar();
	return 0;
}
